package model;

import javax.swing.event.EventListenerList;

public class BoatModel {
	//Valeur du cap (concept du domaine)
	private int heading;
	//Valeur de vitesse (concept du domaine)
	private int speed;
	
	//Liste des vues qui écoutent les évènements de type HeadingChangedEvent
	private EventListenerList headingListeners;
	//Liste des vues qui écoutent les évènements de type SpeedChangedEvent
	//à vous
	
	public BoatModel(){
		this(0,0);
	}
	
	public BoatModel(int heading,int speed){
		headingListeners=new EventListenerList();
		//à vous
		setHeading(heading);
		setSpeed(speed);
	}
	
	public int getHeading(){return heading;}
	//initialistion du cap à une valeur donnée
	public void setHeading(int heading){
		if(heading<0){
			this.heading=360+heading;
		}else if(heading>=360){
			this.heading=heading-360;
		}else{
			this.heading=heading;
		}
		//dès que le cap change, on déclenche la methode d'envoi des évènements aux vues
		fireHeadingChanged();
	}

	public int getSpeed(){return speed;}
	public void setSpeed(int speed){
		//à vous
	}
	
	
	//gestion des évènements
	//ajouter une vue (qui implemente HeadingListener) à la liste des objets écoutant. 
	public void addHeadingListener(HeadingListener listener){
		headingListeners.add(HeadingListener.class, listener);
	}
	//supprimer une vue de la liste des objets écoutant.
	public void removeHeadingListener(HeadingListener listener){
		headingListeners.remove(HeadingListener.class, listener);
	}
	
//	public void addSpeedListener(???){
//		//à vous
//	}
//	public void removeSpeedListener(???){
//		//à vous
//	}
	
	private void fireHeadingChanged(){
		//parcours de la liste des vues...
		HeadingListener[] listenerList=(HeadingListener[])headingListeners.getListeners(HeadingListener.class);
		for(HeadingListener listener : listenerList){
			//... appel de la methode headingChanged() de chaque vue
			//et envoi d'un nouvel evènement qui contient le cap à jour (getHeading)
			listener.headingChanged(new HeadingChangedEvent(this,getHeading()));
		}
	}
	
	private void fireSpeedChanged(){
		//à vous
	}

}
