package view;

import controler.HeadingControler;
import model.HeadingListener;

//classe abstraite parente des Vues qui affichent le contrôle du cap
//l'abstraction permet de se detacher du toolkit graphique utilisé.
//les classe filles devront implémenter l'interface HeadingListener
public abstract class HeadingView implements HeadingListener{
	//controleur de la Vue. C'est lui qui va faire appel aux methodes display() et close() pour l'affichage de la fenetre.
	private HeadingControler controler = null;
	public HeadingView(HeadingControler controler){
		super();
		this.controler=controler;
	}
	
	public final HeadingControler getControler(){
		return controler;
	}
	//actions a effectuer pour afficher la fenetre
	public abstract void display();
	//actions a effectuer lors de la fermeture
	public abstract void close();
}
