package controler;

import model.BoatModel;
import view.MixedInputUIView;
import view.MixedInputView;

public class MixedInputControler {
	public MixedInputView mixedInputView=null;
	
	private BoatModel model=null;
	
	public MixedInputControler(BoatModel model){
		this.model=model;
		mixedInputView=new MixedInputUIView(this, model.getHeading(),model.getSpeed());
		addListenersToModel();
	}
	
	private void addListenersToModel(){
		model.addHeadingListener(mixedInputView);
		model.addSpeedListener(mixedInputView);
	}
	
	public void displayViews(){mixedInputView.display();}
	public void closeView(){mixedInputView.close();}
	
	public void notifyHeadingSpeedChanged(int heading,int speed){
		model.setHeading(heading);
		model.setSpeed(speed);
	}
}
