package controler;

import model.BoatModel;
import view.MixedUIView;
import view.MixedView;

public class MixedControler {
	public MixedView mixedDisplayView=null;
	private BoatModel model=null;
	
	public MixedControler(BoatModel model){
		this.model=model;
		mixedDisplayView=new MixedUIView(this, model.getHeading(),model.getSpeed());
		addListenersToModel();
	}
	
	private void addListenersToModel(){
		model.addSpeedListener(mixedDisplayView);
		model.addHeadingListener(mixedDisplayView);
	}
	
	public void displayViews(){mixedDisplayView.display();}
	public void closeView(){mixedDisplayView.close();}
	
	public void notifyHeadingSpeedChanged(int heading,int speed){
		model.setHeading(heading);
		model.setSpeed(speed);
	}
}
